'##################################
'Optionen-Dialog fr JPG und PNG
'Andreas Miethe Dezember 2001
'##################################

DEF GetStockObject(1) !"GDI32","GetStockObject"
DEF SetDefaultGUIFont(1) SendMessage(&(1),$30,Val(GetStockObject($11)),1)
DEF UpDown(12) ! "COMCTL32","CreateUpDownControl"
Def MakeLong(2)Or(@&(1),Mul(@&(2),$10000))
'
Proc SetOptions
Declare Option_DLG&,Ok&,Abbruch&
Declare Option_ende%
Declare Qualitaet&,Size&,Color&,Smooth&,Progressiv&,JpgKompress&,JpgKompressedit&
Declare JpgKompressText&
Declare JPGGroup&,PNGGroup&
Declare BitGroup&,8Bit&,24Bit&
Declare SizeGroup&,Full&,Half&,Quarter&,Eigth&
Declare PngKompress&,PngInterlace&,PngTColor&
Declare KompressEdit&,KompressText&
Declare RedVal&,GreenVal&,BlueVal&
Declare ColorText&,RedText&,Greentext&,BlueText&
Declare RedEdit&,GreenEdit&,BlueEdit&
Declare PngSetTransparenz&
Declare SetBit&,SetSpeed&,SetSize&,SetCompress&
Declare SetBack&
'
Proc GetDefault
'Jpg-Defaultwerte lesen
Setcheck Progressiv&,Val(@ReadIni$(@GetDir$("@")+"\Defs.Ini","JpgDefault","progressiv"))
Setcheck Smooth&,Val(@ReadIni$(@GetDir$("@")+"\Defs.Ini","JpgDefault","smoothing"))
Setcheck Color&,Val(@ReadIni$(@GetDir$("@")+"\Defs.Ini","JpgDefault","color"))
Setcheck Qualitaet&,Val(@ReadIni$(@GetDir$("@")+"\Defs.Ini","JpgDefault","speed"))
Setcheck 8Bit&,Val(@ReadIni$(@GetDir$("@")+"\Defs.Ini","JpgDefault","8Bit"))
Setcheck 24Bit&,Val(@ReadIni$(@GetDir$("@")+"\Defs.Ini","JpgDefault","24Bit"))
Setcheck Full&,Val(@ReadIni$(@GetDir$("@")+"\Defs.Ini","JpgDefault","fullsize"))
Setcheck Half&,Val(@ReadIni$(@GetDir$("@")+"\Defs.Ini","JpgDefault","halfsize"))
Setcheck Quarter&,Val(@ReadIni$(@GetDir$("@")+"\Defs.Ini","JpgDefault","quartersize"))
Setcheck Eigth&,Val(@ReadIni$(@GetDir$("@")+"\Defs.Ini","JpgDefault","eigthsize"))
SendMessage(JpgKompress&,$0467,0,MakeLong(Val(@ReadIni$(@GetDir$("@")+"\Defs.Ini","JpgDefault","compress")),0))
'Png-Defaultwerte lesen
SendMessage(PngKompress&,$0467,0,MakeLong(Val(@ReadIni$(@GetDir$("@")+"\Defs.Ini","PngDefault","compress")),0))
SendMessage(RedVal&,$0467,0,MakeLong(Val(@ReadIni$(@GetDir$("@")+"\Defs.Ini","PngDefault","red")),0))
SendMessage(GreenVal&,$0467,0,MakeLong(Val(@ReadIni$(@GetDir$("@")+"\Defs.Ini","PngDefault","green")),0))
SendMessage(BlueVal&,$0467,0,MakeLong(Val(@ReadIni$(@GetDir$("@")+"\Defs.Ini","PngDefault","blue")),0))
Setcheck PngSetTransparenz&,Val(@ReadIni$(@GetDir$("@")+"\Defs.Ini","PngDefault","setcolor"))
Setcheck PngInterlace&,Val(@ReadIni$(@GetDir$("@")+"\Defs.Ini","PngDefault","interlace"))
EndProc
'
Proc SetDefault
'Jpg-Defaultwerte setzen
WriteIni @GetDir$("@")+"\Defs.Ini","JpgDefault","progressiv"=str$(@GetCheck(Progressiv&))
WriteIni @GetDir$("@")+"\Defs.Ini","JpgDefault","smoothing"=str$(@GetCheck(Smooth&))
WriteIni @GetDir$("@")+"\Defs.Ini","JpgDefault","color"=str$(@GetCheck(Color&))
WriteIni @GetDir$("@")+"\Defs.Ini","JpgDefault","speed"=str$(@GetCheck(Qualitaet&))
WriteIni @GetDir$("@")+"\Defs.Ini","JpgDefault","8Bit"=str$(@GetCheck(8Bit&))
WriteIni @GetDir$("@")+"\Defs.Ini","JpgDefault","24Bit"=str$(@GetCheck(24Bit&))
WriteIni @GetDir$("@")+"\Defs.Ini","JpgDefault","fullsize"=str$(@GetCheck(Full&))
WriteIni @GetDir$("@")+"\Defs.Ini","JpgDefault","halfsize"=str$(@GetCheck(Half&))
WriteIni @GetDir$("@")+"\Defs.Ini","JpgDefault","quartersize"=str$(@GetCheck(Quarter&))
WriteIni @GetDir$("@")+"\Defs.Ini","JpgDefault","eigthsize"=str$(@GetCheck(Eigth&))
WriteIni @GetDir$("@")+"\Defs.Ini","JpgDefault","compress"=str$(sendmessage(JpgKompress&,$0468,0,0))
'Png-Defaultwerte setzen
WriteIni @GetDir$("@")+"\Defs.Ini","PngDefault","compress"=str$(sendmessage(PngKompress&,$0468,0,0))
WriteIni @GetDir$("@")+"\Defs.Ini","PngDefault","red"=str$(sendmessage(Redval&,$0468,0,0))
WriteIni @GetDir$("@")+"\Defs.Ini","PngDefault","green"=str$(sendmessage(GreenVal&,$0468,0,0))
WriteIni @GetDir$("@")+"\Defs.Ini","PngDefault","blue"=str$(sendmessage(BlueVal&,$0468,0,0))
WriteIni @GetDir$("@")+"\Defs.Ini","PngDefault","setcolor"=str$(@GetCheck(PngSetTransparenz&))
WriteIni @GetDir$("@")+"\Defs.Ini","PngDefault","interlace"=str$(@GetCheck(PngInterlace&))
EndProc
'
'Dialog-Aufbau
Option_DLG& = Create("Dialog",%HWND,"JPG - PNG - Optionen",%Maxx+1,0,0,0)
SetDefaultGUIFont(Option_DLG&)
OK& = Create("Button",Option_DLG&,"OK",400,10,80,24)
SetDefaultGUIFont(Ok&)
Abbruch& = Create("Button",Option_DLG&,"Abbruch",400,40,80,24)
SetDefaultGUIFont(Abbruch&)
'JPG
JPGGroup& = Create("Groupbox",Option_DLG&,"JPG-Optionen",2,2,186,360)
SetDefaultGUIFont(JPGGroup&)
Progressiv& = Create("CheckBox",JPGGroup&,"Progressiv (speichern)",10,12,170,24)
SetDefaultGUIFont(Progressiv&)
Smooth& = Create("CheckBox",JPGGroup&,"Smoothing (laden)",10,32,170,24)
SetDefaultGUIFont(Smooth&)
Color& = Create("CheckBox",JPGGroup&,"Graustufen (laden && speichern)",10,52,170,24)
SetDefaultGUIFont(Color&)
Qualitaet& = Create("CheckBox",JPGGroup&,"Speed (laden)",10,72,170,24)
SetDefaultGUIFont(Qualitaet&)
BitGroup& = Create("Groupbox",JPGGroup&,"Bit-Tiefe (laden && speichern)",10,102,170,70)
SetDefaultGUIFont(BitGroup&)
8Bit& = Create("Radiobutton",BitGroup&,"8-Bit",10,20,80,24)
SetDefaultGUIFont(8Bit&)
24Bit& = Create("Radiobutton",BitGroup&,"24-Bit",10,40,80,24)
SetDefaultGUIFont(24Bit&)
SizeGroup& = Create("Groupbox",JPGGroup&,"Groesse (laden)",10,182,170,110)
SetDefaultGUIFont(SizeGroup&)
Full& = Create("Radiobutton",SizeGroup&,"Volle Grsse",10,20,100,24)
SetDefaultGUIFont(Full&)
Half& = Create("Radiobutton",SizeGroup&,"Halbe Grsse",10,40,100,24)
SetDefaultGUIFont(Half&)
Quarter& = Create("Radiobutton",SizeGroup&,"Viertel Grsse",10,60,100,24)
SetDefaultGUIFont(Quarter&)
Eigth& = Create("Radiobutton",SizeGroup&,"Achtel Grsse",10,80,100,24)
SetDefaultGUIFont(Eigth&)
JpgKompressEdit& = Createedit(JPGGroup&,"",10,300,60,20)
SetDefaultGUIFont(JpgKompressEdit&)
JpgKompress&=UpDown($540001B6,0,0,0,0,JpgGroup&,1002,%hinstance,JpgKompressEdit&,100,1,0)
SetDefaultGUIFont(JpgKompress&)
JpgKompressText& = CreateText(JPGGroup&,"Kompresions-Stufe in %",10,330,120,20)
SetDefaultGUIFont(JpgKompressText&)
'PNG
PNGGroup& = Create("Groupbox",Option_DLG&,"PNG-Optionen",200,2,186,220)
SetDefaultGUIFont(PNGGroup&)
KompressEdit& = Createedit(PNGGroup&,"",10,20,60,20)
SetDefaultGUIFont(KompressEdit&)
PngKompress&=UpDown($540001B6,0,0,0,0,PNGGroup&,1002,%hinstance,KompressEdit&,9,0,0)
SetDefaultGUIFont(PngKompress&)
KompressText& = CreateText(PNGGroup&,"Kompresions-Stufe (0-9)",60,22,120,20)
SetDefaultGUIFont(KompressText&)
Create("Groupbox",PNGGroup&,"",2,50,182,9)'Linie
Colortext& = CreateText(PNGGroup&,"Transparenz-Farbe",10,70,100,20)
SetDefaultGUIFont(ColorText&)
RedEdit& = Createedit(PNGGroup&,"",10,90,60,20)
SetDefaultGUIFont(RedEdit&)
RedVal&=UpDown($540001B6,0,0,0,0,PNGGroup&,1002,%hinstance,RedEdit&,255,0,0)
SetDefaultGUIFont(RedVal&)
Redtext& = CreateText(PNGGroup&,"Rotwert",10,112,50,20)
SetDefaultGUIFont(RedText&)
GreenEdit& = Createedit(PNGGroup&,"",70,90,60,20)
SetDefaultGUIFont(GreenEdit&)
GreenVal&=UpDown($540001B6,0,0,0,0,PNGGroup&,1002,%hinstance,GreenEdit&,255,0,0)
SetDefaultGUIFont(GreenVal&)
Greentext& = CreateText(PNGGroup&,"Grnwert",70,112,50,20)
SetDefaultGUIFont(GreenText&)
BlueEdit& = Createedit(PNGGroup&,"",130,90,60,20)
SetDefaultGUIFont(BlueEdit&)
BlueVal&=UpDown($540001B6,0,0,0,0,PNGGroup&,1002,%hinstance,BlueEdit&,255,0,0)
SetDefaultGUIFont(BlueVal&)
Bluetext& = CreateText(PNGGroup&,"Blauwert",130,112,50,20)
SetDefaultGUIFont(BlueText&)
PngSetTransparenz& = Create("CheckBox",PNGGroup&,"Transparenzfarbe setzen",10,130,170,24)
SetDefaultGUIFont(PngSetTransparenz&)
Create("Groupbox",PNGGroup&,"",2,160,182,9)'Linie
PngInterlace& = Create("CheckBox",PNGGroup&,"Interlace (speichern)",10,180,170,24)
SetDefaultGUIFont(PngInterlace&)
'
GetDefault
'Position
Setwindowpos Option_DLG& = 60,60 - 500,400
Whilenot Option_ende%
        if getFocus (ok&)
                SetDefault
                Case @GetCheck(8Bit&) = 1 : SetBit& = 8
                Case @GetCheck(24Bit&) = 1 : SetBit& = 24
                Case @GetCheck(Full&) = 1 : SetSize& = 0
                Case @GetCheck(Half&) = 1 : SetSize& = 1
                Case @GetCheck(Quarter&) = 1 : SetSize& = 2
                Case @GetCheck(Eigth&) = 1 : SetSize& = 3
                ~P_SetExtJpgOptions(SetBit&,@GetCheck(Qualitaet&),\
                SetSize&,@GetCheck(Color&),\
                @GetCheck(Smooth&),@GetCheck(Progressiv&),\
                sendmessage(JpgKompress&,$0468,0,0))

                Case @GetCheck(PngSetTransparenz&) = 1 : \
                SetBack& = RGB(sendmessage(RedVal&,$0468,0,0),\
                sendmessage(GreenVal&,$0468,0,0),\
                sendmessage(BlueVal&,$0468,0,0))
                Case @GetCheck(PngSetTransparenz&) = 0 : SetBack& = -1
                ~P_SetPngOptions(SetBack&,sendmessage(PngKompress&,$0468,0,0),@GetCheck(PngInterlace&))
                Option_ende% = 1                
                DestroyWindow(Option_DLG&)        
        elseif GetFocus(Abbruch&)
                DestroyWindow(Option_DLG&)        
        endif        
EndWhile
EndProc
